/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/***************************************************************************
  
  tefax constant string source funktions
  
***************************************************************************/
/***************************************************************************
  
  cs liefert die konstanten und strings an das programm
  
***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <curses.h>
#include "tefaxdef.h"
#include "hcs.h"

/**************************************************************************/

/* dieses array ohne bestimmte laenge ist beliebig erweiterbar. die einzelnen zeilen
** werden beim aufruf der funktion w seitenweise angezeigt oder durch den kommandozeilen-
** schalter -W der reihe nach (ab zeile 1) in die standardausgabe geschrieben
*/
    char *gnutext[] = {
/*       12345678901234567890123456789012345678901234567890123456789012345678901234567890 */

        "\n    hit \"q\" to quit this text, an other key to scroll",
        "    tefax  -- front end to handle FAXes with efax or mgetty&sendfax        \n",
        "              and certain programms for view and print                     \n",
        "                                                                           \n",
        "    Copyright (C) 1997  Kai Uwe Tempel                                     \n",
        "                                                                           \n",
        "    This program is free software; you can redistribute it and/or modify   \n",
        "    it under the terms of the GNU General Public License as published by   \n",
        "    the Free Software Foundation; either version 1, or (at your option)    \n",
        "    any later version.                                                     \n",
        "                                                                           \n",
        "    This program is distributed in the hope that it will be useful,        \n",
        "    but WITHOUT ANY WARRANTY; without even the implied warranty of	    \n",
        "    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	    \n",
        "    GNU General Public License for more details.			    \n",
        "									    \n",
        "    You should have received a copy of the GNU General Public License	    \n",
        "    along with this program; if not, write to the Free Software	    \n",
        "    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		    \n",
        "									    \n",
        "    please send any bug reports, suggestions, greetings etc. to	    \n",
        "	temu@server3.medizin.uni-leipzig.de                                 \n",
        "									    \n",
        "    or contact me in							    \n",
        "	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany	    \n",
        "									    \n",
        "    call or fax: +49 341 4126014					    \n",
        "                                                                           \n",
	"    enjoy!                                                                 \n",
     };
    
/* dieses array ohne bestimmte laenge ist beliebig erweiterbar. die einzelnen zeilen
** werden beim aufruf der funktion seitenweise angezeigt
*/
    char *helptext[] = {
/*       12345678901234567890123456789012345678901234567890123456789012345678901234567890 */
        "\n    hit \"q\" to quit help text, an other key for more",
        "                       TEFAX  ---    HELP                                     \n",
        "                                                                              \n",
        "    s    invokes the editor and send the file as fax to desired adress        \n",
        "    S    don't invoke editor, select any ps- g3- or text-files for send       \n",
        "    f    forward the highlighted fax                                          \n",
        "    F    forward faxfiles (select only g3-files)                              \n",
        "    c    invoking editor for call back the sender off the highlighted fax     \n",
        "    C    don't invoke editor, only choose the file(s) to send back to the     \n",
        "           sender of the highlighted fax                                      \n",
        "                                                                              \n",
        "    r    shows the highlighted fax in a (readable) size (using gs or xv)      \n",
        "    v    shows the highlighted fax fully                (using gs or xv)      \n",
        "    g    shows the highlighted fax               (using g3view or g3vga)      \n",
        "    p    prints the highlighted fax                          (using lpr)      \n",
        "    R    shows any select g3-files in a (readable) size (using gs or xv)      \n",
        "    V    shows any select g3-files fully                (using gs or xv)      \n",
        "    G    shows any select g3-files               (using g3view or g3vga)      \n",
        "    P    prints any select g3-files                          (using lpr)      \n",
        "    n    deletes a name from the faxdir-file                                  \n",
        "                                                                              \n",
        "    j    moves the highlighted bar down   (same as DOWN-ARROW)                \n",
        "    k    moves the highlighted bar up     (same as UP-ARROW)                  \n",
        "    h    set the resolution for processing files or faxes to high (fine)      \n",
        "    l    set the resolution for processing files or faxes to low (normal)     \n",
        "    B    switch fax box to received folder/incoming folder                    \n",
        "    b    switch fax box - same as B                                           \n",
	"                                                                              \n",
	"    t    sort faxlist by arrivetime ( T sort in reverse order)                \n",
	"    u    sort faxlist by filename   ( U sort in reverse order)                \n",
	"    z    sort faxlist by sendername ( Z sort in reverse order)                \n",
	"                                                                              \n",
	"    ?    shows this help text                                                 \n",
	"    w    shows LICENCE information                                            \n",
	"    !    starts a shell                                                       \n",
     };
    
/* printhelptext() gibt den hilfetext als einzigen string in die standard-
** ausgabe und wird nur durch die kommandozeilenauswertung aufgerufen
*/

void printhelptext(char *my_name)
{
    printf("usage: \n\
%s [-[aACdFGhiIlmMVwxX][n|N][o|O][p|P][q|Q][r|R][s|S]]\n\
\t [-c CONFIGFILE] [-f FAXDIR]\n\n\
 -a\tautoset faxresolution\n\
 -A\tdon't set faxresolution by detect\n\
 -c\tuse CONFIGFILE instead of ~/%s or ./%s\n\
 -C\tprint out all configuration variable settings and exit\n\
 -d\tassume that homedir is the same as current working directory\n\
 -f\tuse FAXDIR instead of ~/.faxdir or setting in config file\n\
 -F\tdon't use the fax script and efax, with -M means send nothing\n\
 -G\tdon't use ghostview\n\
 -h\tprints this help text and exit\n\
 -i\tmemory last read incoming-path (g3)\n\
 -I\tdon't memory last read incoming-path (g3)\n\
 -l\trun efax local even if server is spezified in configfile\n\
 -m\tread a mail from standard input and produces a file in\n\
 \t\tthe incoming dir that contains the name of sender\n\
 -M\tdon't use mgetty&sendfax, with -F means send nothing\n\
 -n\tpreset phone number\n\
 -N\tdon't preset phone number\n\
 -o\tmemory last read outgoing-path (text)\n\
 -O\tdon't memory last read outgoing-path (text)\n\
 -p\tproxy - saving g3 from server for next access\n\
 -P\tno proxy - don't saving g3 from server for next access\n\
 -q\tquiet, don't ask for confirm\n\
 -Q\task for confirm before delete operations\n\
 -r\tremove ps and pgm files on exit\n\
 -R\tdon't remove ps and pgm files on exit\n\
 -s\tsuppress programm check\n\
 -S\tdon't suppress programm check\n\
 -v\tprint version to stdout and exit\n\
 -V\tdon't use xv\n\
 -w\twrite syscalls to syscall file, but don't execute it\n\
 -W\tprint LICENCE information to stdout and exit\n\
 -x\tdon't start an X-terminal\n", 
	   my_name, S_(fl_confighome), S_(fl_configcwd));
}

/* die on-line-hilfe. aufruf durch ein fragezeichen im hauptmenue */

void printmainhelp()
{
    WINDOW *helpwin = newwin(24,80,0,0);
    int i;
    
/* 
** zunaechst die ncurses-routinen 
*/
    if (!helpwin) return;
    wclear(helpwin);
    scrollok(helpwin, TRUE);
    cbreak();

/* 
** nach jeweils 22 angezeigten zeilen eingabe abwarten. die wmove()-anweisung
** ueberschreibt die eingabeaufforderung, damit diese sich nach dem scrollen
** nicht mitten auf dem bildschirm befindet
*/
    for (i=1; i < (sizeof(helptext) / sizeof(char *)); i++) {
        waddstr(helpwin, helptext[i]);
        if (i % 22 == 0) {
            waddstr(helpwin, helptext[0]);
            wrefresh(helpwin);
            if (wgetch(helpwin) == MK_QUIT) {
	      wclear(helpwin);
	      wrefresh(helpwin);
	      nocbreak();
	      delwin(helpwin);
	      return;
	    }
            wmove(helpwin, 22, 0);
        }   
    } 
    waddstr(helpwin, helptext[0]);
    wrefresh(helpwin);
    wgetch(helpwin);
    wclear(helpwin);
    wrefresh(helpwin);
    delwin(helpwin);
    nocbreak();
}

void gnutextout()
{
    int i;
    for (i=1; i < (sizeof(gnutext) / sizeof(char *)); i++)
      printf("%s", gnutext[i]);
}

void print_gnu()
{
    WINDOW *helpwin = newwin(24,80,0,0);
    int i;

/* 
** zunaechst die ncurses-routinen 
*/
    if (!helpwin) return;
    wclear(helpwin);
    scrollok(helpwin, TRUE);
    cbreak();

/* 
** nach jeweils 22 angezeigten zeilen eingabe abwarten. die wmove()-anweisung
** ueberschreibt die eingabeaufforderung, damit diese sich nach dem scrollen
** nicht mitten auf dem bildschirm befindet
*/
    for (i=1; i < (sizeof(gnutext) / sizeof(char *)); i++) {
        waddstr(helpwin, gnutext[i]);
        if (i % 22 == 0) {
            waddstr(helpwin, gnutext[0]);
            wrefresh(helpwin);
            if (wgetch(helpwin) == MK_QUIT) {
	      wclear(helpwin);
	      wrefresh(helpwin);
	      nocbreak();
	      delwin(helpwin);
	      return;
	    }
            wmove(helpwin, 22, 0);
        }   
    } 
    waddstr(helpwin, gnutext[0]);
    wrefresh(helpwin);
    wgetch(helpwin);
    wclear(helpwin);
    wrefresh(helpwin);
    delwin(helpwin);
    nocbreak();
}

/* eine der wichtigsten funktionen: stellt alle benoetigten variablen strings
** durch die macros in hcs.h zur verfuegung, bzw. verwaltet sie.
 */
char *string_tab(int i, char *p, int m)
{
  static char *tefax_string[uni_no + 1][3]; /* laenge wird durch die enum-variable in hcs.h
					    ** bestimmt.
					    ** spalte [0]: kennung der variablen fuer config-file
					    ** spalte [1]: nullzeiger, der auf den entsprechenden
					    **             string umgebogen wird. der speicher MUSS
					    **	           von malloc() stammen
					    ** spalte [2]: voreinstellung. wird durch die belegung
					    **             von [1] z.B. auf dem config-file nicht mehr
					    **	           verwendet*/

  static int ind = 0;                       /* beim ersten aufruf muss das array indiziert werden*/
  
  if (!ind) {
    int k;

    ind = 1;
    for(k = 0; k <= uni_no; k++) {
      tefax_string[k][0] = NULL;
      tefax_string[k][1] = NULL;
      tefax_string[k][2] = NULL;
    }    
/* 
** die reihenfolge der folgenden angaben spielt keine rolle, da die felder im array
** durch die zeilennummer angesprochen werden, die in hcs.h definiert ist
*/

    tefax_string[SETABLE][0] = "presets";

    /********************************************************************************
      pth -- pathnames
      ********************************************************************************/
    tefax_string[pth_etc][2] = "/usr/local/etc";
    tefax_string[pth_ic][0]  = "incoming path";
    tefax_string[pth_ic][2]  = "/usr/spool/fax/incoming";
    tefax_string[pth_ric][0] = "copy ric to";
    tefax_string[pth_ric][2] = "~/.TEFAXFILES/copy.in";
    tefax_string[pth_og][0]  = "outgoing path";
    tefax_string[pth_og][2]  = "~";
    tefax_string[pth_rog][0] = "copy rog to";
    tefax_string[pth_rog][2] = "";
    tefax_string[pth_my][0]  = "tefax path";
    tefax_string[pth_my][2]  = "~/.TEFAXFILES";
    tefax_string[pth_log][0] = "logfile path";
    tefax_string[pth_log][2] = "~/.TEFAXFILES/log";
    tefax_string[pth_del][0] = "received path";
    tefax_string[pth_del][2] = "~/.TEFAXFILES/received";
    tefax_string[pth_ps][0]  = "ps-file path";
    tefax_string[pth_ps][2]  = "~/.TEFAXFILES/ps";
    tefax_string[pth_pgm][0] = "pgm-file path";
    tefax_string[pth_pgm][2] = "~/.TEFAXFILES/pgm";
    /*********************************************************************************
      fl -- filenames
      *********************************************************************************/
    tefax_string[fl_logfile][0]     = "log file";
    tefax_string[fl_logfile][2]     = "~/.TEFAXFILES/log/log.tefax";
    tefax_string[fl_confighome][2]  = ".tefaxrc";
    tefax_string[fl_configetc][2]   = "tefaxrc";
    tefax_string[fl_configcwd][2]   = "config";
    tefax_string[fl_fax_ser][0]     = "fax file at server"; /*  */
    tefax_string[fl_fax_ser][2]     = "FAXATSERVER"; /*  */
    tefax_string[fl_sysc_lg][0]     = "syscall log file";
    tefax_string[fl_sysc_lg][2]     = "~/.TEFAXFILES/log/syscalls";
    tefax_string[fl_func_lg][0]     = "function log file";
    tefax_string[fl_func_lg][2]     = "~/.TEFAXFILES/log/LOGFUNCTEFAX";
    tefax_string[fl_faxatserver][0] = "fax at server file";
    tefax_string[fl_faxatserver][2] = "~/.TEFAXFILES/faxatserver";
    tefax_string[fl_faxdirfile][0]  = "faxdir file";
    tefax_string[fl_faxdirfile][2]  = "~/.faxdir";
    tefax_string[fl_faxdircopy][0]  = "faxdir copy file";
    tefax_string[fl_faxdircopy][2]  = "~/.TEFAXFILES/faxdir.copy";
    tefax_string[fl_faxdirtemp][0]  = "faxdir temp file";
    tefax_string[fl_faxdirtemp][2]  = "~/.TEFAXFILES/.faxdir.tmp";
    /*********************************************************************************
      fm -- format definitions
      *********************************************************************************/
    tefax_string[fm_readconfig][2]    = "%[^=]= %[^\n]";
    tefax_string[fm_readfaxdir_f][0]  = "fm_readfaxdir";
    tefax_string[fm_readfaxdir_f][2]  = "fax(%[^)]): %[^\n]";
    tefax_string[fm_writefaxdir_f][0] = "fm_writefaxdir";
    tefax_string[fm_writefaxdir_f][2] = "fax(%s):\t%s\n";
    tefax_string[fm_readfaxdir][0]    = "fm_readfaxdir_sendfax";
    tefax_string[fm_readfaxdir][2]    = "%s %[^\n]";
    tefax_string[fm_writefaxdir][0]   = "fm_writefaxdir_sendfax";
    tefax_string[fm_writefaxdir][2]   = "%s\t%s\n";
    /*********************************************************************************
      cl -- commandlines
      *********************************************************************************/
    tefax_string[cl_move][0]     = "mv";
    tefax_string[cl_move][2]     = "mv";
    tefax_string[cl_lpr][0]      = "lpr";
    tefax_string[cl_lpr][2]      = "lpr";
    tefax_string[cl_mkdir][0]    = "mkdir";
    tefax_string[cl_mkdir][2]    = "mkdir";
    tefax_string[cl_remove][0]   = "rm";
    tefax_string[cl_remove][2]   = "rm";
    tefax_string[cl_ps][0]       = "ps";
    tefax_string[cl_ps][2]       = "ps";
    tefax_string[cl_rshell][0]   = "rsh";
    tefax_string[cl_rshell][2]   = "rsh";
    tefax_string[cl_rcopy][0]    = "rcp";
    tefax_string[cl_rcopy][2]    = "rcp";
    tefax_string[cl_copy][0]     = "cp";
    tefax_string[cl_copy][2]     = "cp";
    tefax_string[cl_null][0]     = "dev/null";
    tefax_string[cl_null][2]     = "/dev/null";
    tefax_string[cl_ls][0]       = "bin/ls";
    tefax_string[cl_ls][2]       = "/bin/ls";
    tefax_string[cl_lso][0]      = "ls options";
    tefax_string[cl_lso][2]      = "--format=long --dereference --classify --ignore-backups";
    tefax_string[cl_lsd][0]      = "ls option -d";
    tefax_string[cl_lsd][2]      = "--directory";
    tefax_string[cl_echo][0]     = "echo";
    tefax_string[cl_echo][2]     = "echo";
    tefax_string[cl_grep][0]     = "grep";
    tefax_string[cl_grep][2]     = "grep";
    tefax_string[cl_type][0]     = "type";
    tefax_string[cl_type][2]     = "type";
    tefax_string[cl_cut][0]      = "cut"; /* cut wird zur ueberpruefung des servers verwendet */
    tefax_string[cl_cut][2]      = "cut";
    tefax_string[cl_cuto][0]     = "cut options";
    tefax_string[cl_cuto][2]     = "-d ' ' -f 3";
    tefax_string[cl_shell][0]    = "shell";
    tefax_string[cl_shell][2]    = "bash";
    /*  */
    tefax_string[avl_edit][0]    = "editor";
    tefax_string[avl_edit][2]    = "vi";
    tefax_string[avl_xedit][0]   = "xeditor";
    tefax_string[avl_xedit][2]   = "xedit";
    tefax_string[avl_gs][0]      = "gs";
    tefax_string[avl_gs][2]      = "gs";
    tefax_string[avl_xv][0]      = "xv";
    tefax_string[avl_xv][2]      = "xv";
    tefax_string[avl_g3view][0]  = "g3view";
    tefax_string[avl_g3view][2]  = "g3view";
    tefax_string[avl_ghost][0]   = "ghostview";
    tefax_string[avl_ghost][2]   = "ghostview";
    tefax_string[avl_g3vga][0]   = "g3vga";
    tefax_string[avl_g3vga][2]   = "g3vga";
    tefax_string[avl_fax][0]     = "efax";
    tefax_string[avl_fax][2]     = "fax";
    tefax_string[avl_sendfax][0] = "sendfax";
    tefax_string[avl_sendfax][2] = "faxspool";
    tefax_string[avl_efix][0]    = "efix";
    tefax_string[avl_efix][2]    = "efix";
    tefax_string[co_x_edit][0]   = "xterm edit";
    tefax_string[co_x_edit][2]   = "xterm -geometry 80x25-513+340 +vb -sb -T \"edit a fax message\" -e";
    tefax_string[co_x_term][0]   = "xterm tefax";
    tefax_string[co_x_term][2]   = "xterm -geometry 81x25-513+340 +vb -sb -T \"tefax - the front end for efax\" -e";

    tefax_string[co_server][0]   = "faxserver";
    tefax_string[co_login][0]    = "remote login";
    tefax_string[co_send_f][0]   = "fax send";
    tefax_string[co_send_f][2]   = "fax send";
    tefax_string[co_send][0]     = "sendfax send";
    tefax_string[co_send][2]     = "faxspool";
    tefax_string[co_low_f][0]    = "switch low";
    tefax_string[co_low_f][2]    = "-l";
    tefax_string[co_low_v][0]    = "switch low g3view";
    tefax_string[co_low_v][2]    = "-n"; 
    tefax_string[co_low][0]      = "switch low sendfax";
    tefax_string[co_low][2]      = "-n";
    tefax_string[co_fin_v][0]    = "switch fine g3view";
    tefax_string[co_fin_v][2]    = "";
    tefax_string[co_fin][0]      = "switch fine sendfax";
    tefax_string[co_fin][2]      = "";
    tefax_string[co_gs_quit][0]  = "gs quit file";
    tefax_string[co_gs_quit][2]  = "/usr/lib/ghostscript/quit.ps";
    tefax_string[co_gs_read][0]  = "gs con readable";
    tefax_string[co_gs_read][2]  = "gs -sDEVICE=linux -r9";
    tefax_string[co_gs_view][0]  = "gs con view";
    tefax_string[co_gs_view][2]  = "gs -sDEVICE=linux -r9";
    tefax_string[co_gs_x][0]     = "gs under x";
    tefax_string[co_gs_x][2]     = "gs";
    tefax_string[co_ch_read][0]  = "fine to read ps";
    tefax_string[co_ch_read][2]  = "efix -ops -s2 -p1024x768pt";
    tefax_string[co_cl_read][0]  = "norm to read ps";
    tefax_string[co_cl_read][2]  = "efix -ops -s2x4 -p1024x768pt";
    tefax_string[co_ch_view][0]  = "fine to view ps";
    tefax_string[co_ch_view][2]  = "efix -ops -s1 -p1024x768pt";
    tefax_string[co_cl_view][0]  = "norm to view ps";
    tefax_string[co_cl_view][2]  = "efix -ops -s1x2 -p1024x768pt";
    tefax_string[co_ch_print][0] = "fine to print ps";
    tefax_string[co_ch_print][2] = "efix -ops -r300 -s1.471 -d0,0.125";
    tefax_string[co_cl_print][0] = "norm to print ps";
    tefax_string[co_cl_print][2] = "efix -ops -r300 -s1.471x2.8 -d0,0.125";
    tefax_string[co_xh_read][0]  = "fine to read pgm";
    tefax_string[co_xh_read][2]  = "efix -s2 -r400x340 -opgm";
    tefax_string[co_xl_read][0]  = "norm to read pgm";
    tefax_string[co_xl_read][2]  = "efix -s2x4 -r400x340 -opgm";
    tefax_string[co_xh_view][0]  = "fine to view pgm";
    tefax_string[co_xh_view][2]  = "efix -opgm";
    tefax_string[co_xl_view][0]  = "norm to view pgm";
    tefax_string[co_xl_view][2]  = "efix -s1x2 -opgm";
    /*********************************************************************************
      wo -- working options
    *********************************************************************************/
    tefax_string[wo_needconfirm][0] = "need confirm";
    tefax_string[wo_needconfirm][2] = "yes";
    tefax_string[wo_proxy][0]       = "using proxy";
    tefax_string[wo_proxy][2]       = "yes";
    tefax_string[wo_rm_pxx][0]      = "remove pxx";
    tefax_string[wo_rm_pxx][2]      = "yes";
    tefax_string[wo_p_check][0]     = "program check";
    tefax_string[wo_p_check][2]     = "yes";
    tefax_string[wo_mem_ic][0]      = "memory ic path";
    tefax_string[wo_mem_ic][2]      = "yes";
    tefax_string[wo_mem_og][0]      = "memory og path";
    tefax_string[wo_mem_og][2]      = "yes";
    tefax_string[wo_preset_no][0]   = "preset number";
    tefax_string[wo_preset_no][2]   = "yes";
    tefax_string[wo_autores][0]     = "autoset res";
    tefax_string[wo_autores][2]     = "yes";
    /*********************************************************************************
      ml -- menu lines
    *********************************************************************************/
    tefax_string[mnu_top][2] = "faxbox is in";
    tefax_string[mnu_av][2] = 
      "you can use one of the following commands by typing parenthesized letter:";
    tefax_string[mnu_1][2] = 
      "r)ead,  d)elete,  s)end,  v)iew,  p)rint,  j) move down,  k) move up";
    tefax_string[mnu_1g][2] = 
      "g)3vga,  r)ead,  v)iew,  d)elete,  p)rint,  j) move down,  k) move up";
    tefax_string[mnu_1gx][2] = 
      "g)3view,  r)ead,  v)iew,  d)elete,  p)rint,  j) move down,  k) move up";
    tefax_string[mnu_1s][2] =
      "j) move down, k) move up to select entry";
    tefax_string[mnu_2s][2] =
      "s)end it,  f)orget it,  r)emove entry,  a)ppend another file(s)";
    tefax_string[mnu_2s0][2] =
      "f)orget it,  a)ctivate new list";
    tefax_string[mnu_1fn][2] =
      "<TAB> completes, <UP> and <DOWN> moves the list,  <ESC> cancel";
    tefax_string[mnu_2l][2] = 
      "set l)owres faxe,  s)end,  f)orward,  c)all back,  ?) help,  q)uit";
    tefax_string[mnu_2h][2] = 
      "set h)ighres faxe,  s)end,  f)orward,  c)all back,  ?) help  q)uit";
    tefax_string[mnu_2f][2] =
      "<*> select all matches,  incomplete filenames will replaced by first match";
    tefax_string[mnu_2n][2] =
      "blank field cancel,  new names will be added to the faxdir-file";
    tefax_string[mnu_cmd][2]    = "command: ";
    tefax_string[mna_send][2]   = "send";
    tefax_string[mna_forget][2] = "forget";
    tefax_string[mna_quit][2]   = "quit";
    tefax_string[mna_f_fax][2]  = "forward fax";
    tefax_string[mna_f_file][2] = "forward file";
    tefax_string[mna_c_back][2] = "call back";
    tefax_string[mna_d_fax][2]  = "delete fax";
    tefax_string[mna_d_file][2] = "remove file";
    tefax_string[mna_d_name][2] = "delete name";
    tefax_string[mna_a_file][2] = "append file";
    tefax_string[mna_p_fax][2]  = "print fax";
    tefax_string[mna_p_file][2] = "print file";
    tefax_string[mna_v_fax][2]  = "view fax";
    tefax_string[mna_v_file][2] = "view file";
    tefax_string[mna_g_fax][2]  = "show fax";
    tefax_string[mna_g_file][2] = "show file";
    tefax_string[mna_r_fax][2]  = "read fax";
    tefax_string[mna_r_file][2] = "read file";
    /*********************************************************************************
      st -- status line
    *********************************************************************************/
    tefax_string[sts_gf][2] = "getting files from server";
    tefax_string[sts_cf][2] = "converting files";
    tefax_string[sts_pf][2] = "printing files";
    tefax_string[sts_uf][2] = "upload files at server";
    tefax_string[sts_ri][2] = "reading incoming fax";
    tefax_string[sts_rd][2] = "reading faxdir";
    tefax_string[sts_ud][2] = "update faxdir";
    tefax_string[sts_lg][2] = "loading g3vga";
    tefax_string[sts_lv][2] = "loading g3view";
    tefax_string[sts_lx][2] = "loading xv"; 
    tefax_string[sts_ls][2] = "loading gs";
    /*********************************************************************************
    *********************************************************************************/
    
    tefax_string[ask_creat][2] = "shall I create";
    tefax_string[ask_yn][2]    = "? [y/n]:";
    tefax_string[sts_ask][2]   = "send these file(s)? s";
    tefax_string[sts_ask0][2]  = "activate new list? a";
    tefax_string[sts_wrote][2] = "wrote file";
    tefax_string[sts_sent][2]  = "file(s) sent";
    tefax_string[sts_nos][2]   = "file(s) not sent";
    tefax_string[sts_noc][2]   = "file(s) not changed";
    tefax_string[sts_fdel][2]  = "file(s) deleted";
    tefax_string[sts_ndel][2]  = "name deleted";
    tefax_string[sts_high][2]  = "setting resolution to high (fine)";
    tefax_string[sts_low][2]   = "setting resolution to low (normal)";
    tefax_string[sts_fbc][2]   = "fax box changed";
    tefax_string[sts_file][2]  = "select a file ...";
    tefax_string[sts_name][2]  = "select a name ...";
    /*********************************************************************************
    *********************************************************************************/
    
    tefax_string[ask_1][2]         = "i will";
    tefax_string[ask_2][2]         = "now, soon. that's right?: y";
    tefax_string[ask_2s][2]        = ", ok?: y";
    tefax_string[ask_delete][2]    = "delete";
    tefax_string[ask_allnam][2]    = "all names that contains";
    tefax_string[ask_really_do][2] = "really do that? please answer yes or no !";
    
    /*********************************************************************************
    *********************************************************************************/
    
    tefax_string[hl_send_to][2]   = "send to: ";
    tefax_string[hl_forw_t][2]    = "forward to: ";
    tefax_string[hl_forw_f][2]    = "forward file(s): ";
    tefax_string[hl_forward][2]   = "forward";
    tefax_string[hl_call_back][2] = "call back: ";
    tefax_string[hl_to][2]        = "to: ";
    tefax_string[hl_call_no][2]   = "                    call number: "; /* leerzeichen */
    tefax_string[hl_del_no][2]    = "delete name: "; 
    tefax_string[hl_read_h][2]    = "read high-res fax: ";
    tefax_string[hl_read_l][2]    = "read low-res fax: ";
    tefax_string[hl_show_h][2]    = "show high-res fax: ";
    tefax_string[hl_show_l][2]    = "show low-res fax: ";
    tefax_string[hl_view_x][2]    = "view with g3view: ";
    tefax_string[hl_view_c][2]    = "view with g3vga: ";
    tefax_string[hl_prnt_h][2]    = "print high-res fax: ";
    tefax_string[hl_prnt_l][2]    = "print low-res fax: ";
    tefax_string[hl_send_f][2]    = "send file(s): ";
    
    /*********************************************************************************
    *********************************************************************************/
    
    tefax_string[er_creat][2]  = "can't create";
    tefax_string[er_book][2]   = "can't open phonebook. please read the manual";
    tefax_string[er_home][2]   = "can't found the home-directory\n";
    tefax_string[er_open][2]   = "can't open";
    tefax_string[er_hope][2]   = "but I will use the default settings, hopefully that works";
    tefax_string[er_neit][2]   = "can't found any configfile";
    tefax_string[er_nor][2]    = "nor";
    tefax_string[er_abort][2]  = "to abort type [q], else hit RETURN to continue";
    tefax_string[er_cfg1][2]   = "you should copy the /etc/tefaxrc to ~/.tefaxrc and";
    tefax_string[er_cfg2][2]   = "edit it for your own settings. if you don't abort now";
    tefax_string[er_cfg3][2]   = "I will use the default settings, hopefully that works";
    tefax_string[er_view][2]   = "can't found neither efix (and xv) nor g3view";
    tefax_string[er_noway1][2] = "there's no way to show or print any g3-files";
    tefax_string[er_vga][2]    = "can't found neither efix nor g3vga";
    tefax_string[er_efix][2]   = "can't found efix. need that for convert g3 in print-format";
    tefax_string[er_print][2]  = "there's no way print any g3-files";
    tefax_string[er_eroc][2]   = "there is an unknown error occured";
    tefax_string[er_dono][2]   = "no description for reason, consequences or device";
    
    /*********************************************************************************
    *********************************************************************************/
    
    
    tefax_string[inf_recv][2] = "efax: received ";/* suchstring faxfile */
/*  tefax_string[inf_ftsi][2] = "efax: [+FTSI: \""; */
    tefax_string[inf_ftsi][2] = "efax: response \"+FTSI:";
    tefax_string[inf_file][2] = "last file of fax is"; /* messages for output of tefax -m */
    tefax_string[inf_came][2] = "fax cames from";
    tefax_string[inf_nres][2] = "lines. think it's normal resolution";
    tefax_string[inf_fres][2] = "lines. think it's fine resolution";
    tefax_string[inf_98][2]   = "98lpi";    /* m.c */
    tefax_string[inf_fdcs][2] = "efax: response \"+FDCS:";
    tefax_string[inf_use][2]  = "using";
    tefax_string[inf_cfg][2]  = "as configfile";
    tefax_string[inf_book][2] = "as phonebook";
    
    /*********************************************************************************
    *********************************************************************************/
    
    tefax_string[ind_file][2]   = "no such file or direktory";
    tefax_string[ind_tare][2]   = "there are"; 
    tefax_string[ind_no_ent][2] = "no entries to list";   /* uni */
    tefax_string[ind_nofsel][2] = "no files selected";    /* sf.c */
    tefax_string[ind_no_fax][2] = "no faxes in this box"; /* nm.c */
    tefax_string[ind_cnt_rd][2] = "can't read directory";
    
    /*********************************************************************************
    *********************************************************************************/
    tefax_string[msg_d_info][2]  = "for debug information";
    tefax_string[msg_s_call][2]  = "for document system calls";
    tefax_string[msg_env][2]     = "please set the environment $HOME and try again\n";
    tefax_string[msg_store][2]   = "need a directory r/w for storing my files";
    tefax_string[msg_setup][2]   = "set up the configfile or give write-perms in ";
    tefax_string[msg_del][2]     = "need a directory r/w for move deleted faxe";
    tefax_string[msg_g3][2]      = "need a directory r/w for incoming g3-files";
    tefax_string[msg_ps][2]      = "need a directory r/w for my postscripfiles";
    tefax_string[msg_pgm][2]     = "need a directory r/w for my pgm-files";
    tefax_string[msg_log][2   ]  = "need a directory r/w for my log-file";
    tefax_string[msg_home][2]    = "your HOME";
    tefax_string[msg_unknown][2] = "unknown";
    
    /*********************************************************************************
    *********************************************************************************/

    tefax_string[uni_pgm][2] = "pgm";
    tefax_string[uni_on][2 ] = "on";
    tefax_string[uni_try][2] = "try";
    tefax_string[uni_yes][2] = "yes";
    tefax_string[uni_no][2]  = "no";
    /********************************************************************************/
    /********************************************************************************/
    /********************************************************************************/
    /********************************************************************************/
    /*  PRESETS  */
    /********************************************************************************/
    /********************************************************************************/
  }
  
/* case-anweisung entsprechend dem uebergebenen parameter m */
  switch (m) {
  case OPT_GET:	/* den strng in zeile i zurueckgeben */
    if (tefax_string[i][1]) return tefax_string[i][1];
    else return tefax_string[i][2];
  case OPT_PRE:	/* die voreinstellung fuer zeile i zurueckgeben */
    return tefax_string[i][0];
  case OPT_SET:	/* zeiger auf string in zeile i speichern. falls i groesser als
		** CHANGEABLE, nicht-NULL-zeiger ggf. aendern */
    if (i < LOCKED) {
      if (i > CHANGEABLE) {
	free(tefax_string[i][1]); tefax_string[i][1] = NULL;
	if (p) tefax_string[i][1] = strdup(p);
      }
      else if (tefax_string[i][1] == NULL && p) tefax_string[i][1] = strdup(p);
    }
    break;
  case OPT_CHG:	/* zeiger ohne ansehen der person aendern. dieses macro wird vom
		** programm nicht verwendet */
    free(tefax_string[i][1]); tefax_string[i][1] = NULL;
    if (p) tefax_string[i][1] = strdup(p);
    break;
  }


/* die else-if routine ist die ausgangsversion, aber case ist eleganter
  if (m == OPT_GET) {
    if (tefax_string[i][1]) return tefax_string[i][1];
    else return tefax_string[i][2];
  }
  else if (m == OPT_PRE) return tefax_string[i][0];
  else if (m == OPT_SET) {
    if (i < LOCKED) {
      if (i < SETABLE) {
	free(tefax_string[i][1]); tefax_string[i][1] = NULL;
	if (p) tefax_string[i][1] = strdup(p);
      }
      else if (tefax_string[i][1] == NULL && p) tefax_string[i][1] = strdup(p);
    }
  }
  else if (m == OPT_CHG) {
    free(tefax_string[i][1]); tefax_string[i][1] = NULL;
    if (p) tefax_string[i][1] = strdup(p);
  }
  */
/* stets die aktuelle belegung zurueckgeben -- ausser PRE */
  return tefax_string[i][1];
}

long tefax_opt(unsigned int i, int j)
{
/* m ist ein paralleles bitfeld zu k, in dem alle bits gesetzt werden, die in k
** veraendert wurden. die schiebeoperation setzt das i-te (nicht wertigkeit) bit in n
** auf eins. dadurch lassen sich die positionen im bitfeld durch die definitionen in 
** enum-variablen in hcs.h ansprechen
*/
  static long k, m;
  long n = 1;

  i %= 32;
  n <<= i;

  switch (j) {
  case OPT_ALL: /* die komplette long-int zurueckgeben. wird nicht benutzt */
    return m;
    break;
  case OPT_SET:	/* setzen, falls bisher noch nicht veraendert */
    if (!(k & n)) { k |= n; m |= n; return 1; }
    break;
  case OPT_DEL:	/* loeschen, falls bisher noch nicht veraendert */
    if (!(k & n)) { k |= n; m &= ~n; return 0; }
    break;
  case OPT_DEF:	/* define, unbedingt setzen */
    k |= n; m |= n; return 1;
    break;
  case OPT_UND:	/* undefine, unbedingt loeschen */
    k |= n; m &= ~n; return 0;
    break;
  case OPT_CHG:	/* change, bit in position i negieren */
    if (m & n) { m &= ~n; return m & n; }
    else { m |= n; return m & n; }
    break;
  case OPT_GET:	/* abfrage */
    return m & n;
    break;
  default:
    return -1;
  }
  return -1;
}










