/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/***************************************************************************

tefax constant source header file

***************************************************************************/
/***************************************************************************

hcs stellt die macros setzen und auslesen von strings und optionen

***************************************************************************/


#define S_(v)        string_tab(v, NULL, OPT_GET)
#define S_P(v)        string_tab(v, NULL, OPT_PRE)
#define S_S(v,u)     string_tab(v, u, OPT_SET)
#define S_C(v,u)     string_tab(v, u, OPT_CHG)


#define O_GET(v)    tefax_opt(v, OPT_GET)
#define O_SET(v)    tefax_opt(v, OPT_SET)
#define O_DEL(v)    tefax_opt(v, OPT_DEL)
#define O_CHG(v)    tefax_opt(v, OPT_CHG)
#define O_DEF(v)    tefax_opt(v, OPT_DEF)
#define O_UND(v)    tefax_opt(v, OPT_UND)
#define O_ALL       tefax_opt(OPT_ALL)

/***************************************************************************

hcs stellt die bezeichner fuer die constant strings zur verfuegung

***************************************************************************/

enum constant_strings {
  /*  */
  SETABLE,
  wo_needconfirm,
  wo_proxy,
  wo_rm_pxx,
  wo_p_check,
  wo_mem_ic,
  wo_mem_og,
  wo_preset_no,
  wo_autores,			/* 9 */
  FIRSTPROG,			/* 10 */
  avl_gs,			/* test suid */
  avl_g3vga,			/* test suid */
  avl_fax,
  avl_sendfax,
  avl_efix,
  avl_xv,
  avl_g3view,
  avl_ghost,
  avl_edit,
  avl_xedit,			/* 20 */
  LASTPROG,
  /*  */
  co_server,
  co_login,
  pth_rog,
  /*  */
  CHANGEABLE,
  FIRSTPATH,
  pth_my,
  pth_log,
  pth_del,
  pth_ps,			/*  */
  pth_pgm,
  pth_ric,
  PATHCONTROL,
  pth_etc,
  pth_ic,
  pth_og,
  LASTPATH,
  FIRSTFILE,
  fl_logfile,
  fl_syscall,			/*  */
  fl_confighome,
  fl_configetc,
  fl_configcwd,
  fl_tempfaxdir,
  fl_fax_ser,
  fl_sysc_lg,
  fl_func_lg,
  fl_faxatserver,
  fl_faxdirfile,
  fl_faxdircopy,                /* 50 */
  fl_faxdirtemp,
  LASTFILE,
  /*  */
  FIRSTBIN,			
  cl_move,
  cl_lpr,
  cl_mkdir,
  cl_remove,
  cl_ps,
  cl_rshell,
  cl_rcopy,			/*  */
  cl_copy,
  cl_null,
  cl_ls,
  cl_lso,
  cl_lsd,
  cl_echo,
  cl_grep,
  cl_type,
  cl_cut,
  cl_cuto,
  cl_shell,
  LASTBIN,
  FIRSTCOM,			/*  */
  co_x_edit,
  co_x_term,
  co_send_f,
  co_send,
  co_low_f,
  co_low_v,
  co_low,
  co_fin_v,
  co_fin,
  co_gs_quit,			/*  */
  co_gs_read,
  co_gs_view,
  co_gs_x,
  co_ch_read,
  co_cl_read,
  co_ch_view,
  co_cl_view,
  co_ch_print,
  co_cl_print,
  co_xl_read,			/*  */
  co_xh_read,
  co_xl_view,
  co_xh_view,
  LASTCOM,
  LOCKED,
  fm_readconfig,
  fm_readfaxdir_f,
  fm_writefaxdir_f,
  fm_readfaxdir,                /* 100 */
  fm_writefaxdir,
  /*  */
  /*****      mnu -- menu lines    ****************/
  mnu_top,
  mnu_av,
  mnu_1,
  mnu_1g,
  mnu_1gx,
  mnu_1s,
  mnu_2s,			
  mnu_2s0,
  mnu_1fn,			/*  */
  mnu_2l,
  mnu_2h,
  mnu_2f,
  mnu_2n,
  mnu_cmd,
  mna_send,
  mna_forget,
  mna_quit,
  mna_f_fax,
  mna_f_file,			/*  */
  mna_c_back,
  mna_d_fax,
  mna_d_file,
  mna_d_name,
  mna_a_file,
  mna_p_fax,
  mna_p_file,
  mna_v_fax,
  mna_v_file,
  mna_g_fax,			/*  */
  mna_g_file,
  mna_r_fax,
  mna_r_file,
  /*****      sts -- status line    ******************/
  sts_gf,
  sts_cf,
  sts_pf,
  sts_uf,
  sts_ri,
  sts_rd,
  sts_ud,			/*  */
  sts_lg,
  sts_lv,
  sts_lx,
  sts_ls,
  sts_ask,
  sts_ask0,
  sts_wrote,
  sts_sent,
  sts_nos,
  sts_noc,			/* 150 */
  sts_fdel,
  sts_ndel,
  sts_high,
  sts_low,
  sts_fbc,
  sts_file,
  sts_name,
  /*****     ask -- ask line strings    *************/
  ask_creat,
  ask_yn,
  ask_1,                        /*  */
  ask_2,
  ask_2s,
  ask_delete,
  ask_allnam,
  ask_really_do,
  
  /*****    hl -- help lines    *************/
  hl_send_to,
  hl_forw_t,
  hl_forw_f,
  hl_forward,
  hl_call_back,			/*  */
  hl_to,
  hl_call_no,
  hl_del_no,
  hl_read_h,
  hl_read_l,
  hl_show_h,
  hl_show_l,
  hl_view_x,
  hl_view_c,
  hl_prnt_h,			/*  */
  hl_prnt_l,
  hl_send_f,
  
  /*******  er -- error messages    ***********/
  er_creat,
  er_book,
  er_home,
  er_open,
  er_hope,
  er_neit,
  er_nor,
  er_abort,			/*  */
  er_cfg1,
  er_cfg2,
  er_cfg3,
  er_view,
  er_noway1,
  er_vga,
  er_efix,
  er_print,
  er_eroc,
  er_dono,			/* 200 */
  /*****    msg -- messages what is to do    *********/
  msg_d_info,
  msg_s_call,
  msg_env,
  msg_store,
  msg_setup,
  msg_del,
  msg_g3,
  msg_ps,			
  msg_pgm,
  msg_log,			/*  */
  msg_home,
  msg_unknown,
  /******   inf -- info strings    *************/
  inf_recv,
  inf_ftsi,
  inf_file,
  inf_came,
  inf_nres,
  inf_fres,
  inf_98,
  inf_fdcs,			/*  */
  inf_use,
  inf_cfg,
  inf_book,
  /******  ind -- indication something   ***********/
  ind_file,
  ind_tare,
  ind_no_ent,
  ind_nofsel,
  ind_no_fax,
  ind_cnt_rd,
  /*****    uni -- universal strings   ************/
  uni_pgm,			/* 230 */
  uni_on,
  uni_try,
  uni_yes,
  uni_no  /* dies ist der letzte eintrag, er legt die groesse von string_tab fest */
  /* daher muessen alle anderen eintraege davor platziert werden */
};

enum option_op {
  OPT_GET,
  OPT_SET,
  OPT_DEL,
  OPT_DEF,
  OPT_UND,
  OPT_CHG,
  OPT_ALL,
  OPT_PRE,
};

enum option_args {
  ARG_h = LASTPROG,			/* help (21)*/
  ARG_i,			/* interprting mails */
  ARG_n,			/* no syscalls */
  ARG_x,			/* X */
  ARG_l,			/* local */
  ARG_S,			/* print opts */
  ARG_L,       			/* resolution LOW*/
  ARG_d                         /* homedir = current wd */ 
};

/***************************************************************************

zur benutzung von konstanten strings

***************************************************************************/

char *string_tab(int i, char *p, int m);

/***************************************************************************

zur verwaltung der optionen

***************************************************************************/

long tefax_opt(unsigned int i, int j);

/***************************************************************************

zur ausgabe von hilfstexten

***************************************************************************/

void printmainhelp();
void print_gnu();
void gnutextout();
void printhelptext();







