/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/***************************************************************************

tefax ncurses functions header file 

***************************************************************************/
/***************************************************************************

 stellt folgende funktionen zur verfuegung

***************************************************************************/
/***************************************************************************

zur anzeige von unilisten

***************************************************************************/

/* stellt den durch root->name benannten eintrag invers dar 
   falls NULL den n-ten eintrag nach root-day (findsel) bzw. root-next*/
void printinsel(struct unilist *root, int mv, char *(*pf)(struct unilist *));

/* listet die eintraege nach nextsel */
void printinpad(struct unilist *root, int mv, char *(*pf)(struct unilist *));

/* schreibt statt einer liste zwei strings in das listenfenster */
/* falls e(rror) oder d(escription) null sind er_eroc und er_dono 
   voreingestellt, e und d keine const wegen cutonend/-beg */
void printinerr(char *e, char *d);

/* schreibt einen string (< 80 zeichen!) zentriert in das st_fenster
   wenn das argument NULL wird nur eine zeilenschaltung geschrieben ->
   das fenster wird clear. prepare_fsl verwaltet sein statusfenster
   jedoch selbst! */
void printstatus(char *sts);

/* zum menueaufbau eine zeile in einem eigenen fenster: zeile l, string s */
WINDOW *printaline(int l, char *s);

/* zentriert s auf 80 zeichen und ruft  printaline auf */
WINDOW *pacline(int l, char *s);

/* schreibt alle node->full in quotes in den string cline. cline muss auf einen
   mallocierten string zeigen. **cline wird automatisch vergroessert */
char *print_fil(char *newpath, struct unilist *root);

/* print_formattet_link_line:  ausgabefunktion fuer die shellaufrufe
   die daten werden entweder ->full und ->name entnommen und durch
   anfuehrungszeichen (wegen der leerzeichen) geschuetzt zu link-
   befehlen erweitert, die durch semicolon getrennt sind. 
   das ergebnis ist je ein symbolischer link bezeichnet aus og_path
   und ->name auf ->full. uebergabe der link-befehls-liste 
   in mm.c: mm_send() an eine (r)shell
   der speicher wird mit malloc nach bedarf angefordert bzw. erweitert */
char *print_fll(char *newpath, struct unilist *root);

/* fordert eine eingabe im commandfenster und
   schreibt den vollen string der eingabe in das fenster */
int userin();
