/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/***************************************************************************

tefax string processing header file

***************************************************************************/
/***************************************************************************

sp stellt folgende funktionen zur verfuegung

***************************************************************************/
/***************************************************************************

zur bearbeitung von pfadnamen

***************************************************************************/


char *pfnp(const char *c);             /* voller pfad: ...PATH/ */
char *pfnn(const char *c);             /* pfadname ...PATH */
char *cpfnp(const char *c);      /* pfadname ...PATH */
char *pfnf(const char *c);             /* filename */
char *pfnx(const char *c);             /* extension */

int lastchar(const char *s);

/***************************************************************************

zum kuerzen/ zentrieren von strings

***************************************************************************/

char *cutonend(char *s, int i);
char *cutonbeg(char *s, int i);
char *fillforcenter(char *s);

/***************************************************************************

zum konvertieren von monatsnamen <-> num

***************************************************************************/

char *monthname(int i);
int monthtoi(char *name);

/***************************************************************************

zum auslesen von dateien

***************************************************************************/

int getline(char *s, int lim, FILE *f);

/***************************************************************************

zum aufruf der externen programme. alles aufrufe werden in syscalls 
mitgeschrieben

***************************************************************************/
int shellex(char *s);
int shellxx(char *s);

/***************************************************************************

zur verarbeitung eingehender mails vom faxmgr, um den absender und die
aufloesung zu speichern

***************************************************************************/
void seeincoming(void);




