/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/****************************************************************************

tefax functions for test and control any conditions

***************************************************************************/

/*LINTLIBRARY */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include "tefaxdef.h"
#include "hsp.h"
#include "hlf.h"
#include "debug.h"

/***************************************************************************/

int isfile(const char *name)
{
    struct stat stbuf;
    
    CF(isfile);
    CE;
    if (stat(name, &stbuf) == -1)  return -1;
    if (S_ISREG(stbuf.st_mode))
      return 1; 
    else 
      return 0;
}

int isdir(const char *name)
{
    struct stat stbuf;
    
    CF(isdir);
    CE;
    if (stat(name, &stbuf) == -1)  return -1;
    if (S_ISDIR(stbuf.st_mode))
      return 1;
    else 
      return 0;
}

int isdirname(const char *c)
{
    CF(isdirname);
    CE;
    if (lastchar(c) == '/')
      return 1;
    else
      return 0;
}

int isg3(char *c)
{
  char *s, *t;
  int i = 0;

  CF(isg3);
  if (!c) { CE; return 0; }

  /* s und t zeigen auf die extension */
  s = t = pfnx(c);
  if (strlen(s) == 2) {

    /* die files von mgetty */
    if (c[0] == 'f' && (c[1] == 'f' || c[1] == 'n') && 
	(c[11] == '.' || c[11] == '-') && isdigit(*s++) && isdigit(*s++)) i = 1;

    /* die eigenen faxe von sendfax */
    else if (t[0] == 'g' && t[1] == '3') i = 1;
  }
  else if (strlen(s) == 3) {

    /* bei den beiden folgenden abfragen muss s wieder auf t, d.h. den anfang der
    ** dateinamenendung zurueckgesetzt werden */
    /* die eigenen faxe */
    if (c[0] == 'f' && (c[1] == 'a' && c[2] == 'x') && ((s = t)) &&
	isdigit(*s++) && isdigit(*s++) && isdigit(*s++)) i = 1;

    /* die files von efax */
    else if (isdigit(*c) && ((s = t)) &&
	     isdigit(*s++) && isdigit(*s++) && isdigit(*s++)) i = 1;
  }
  CE;
  return i;
}

int isefaxmail(char *c)
{
  CF(isefaxmail);
  CE;
  if (*c == 'z' && (c[1] == 'z' || c[1] == 'f' || c[1] == 'n') && c[2] == '-' && strchr(c, '.'))
    return 1;
  else
    return 0;
}


