/**************************************************************************

    tefax  -- front end to handle FAXes with efax or mgetty&sendfax
              and certain programms for view and print

    Copyright (C) 1997  Kai Uwe Tempel

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    please send any bug reports, suggestions, greetings etc. to
	temu@server3.medizin.uni-leipzig.de

    or contact me in
	Kai Uwe Tempel, Gaertnerstr. 171, 04209 Leipzig, Germany

    call or fax: +49 341 4126014

***************************************************************************/
/****************************************************************************

tefax functions for log function calls

***************************************************************************/

/*LINTLIBRARY */

#include <stdio.h>
#include <string.h>
#include "tefaxdef.h"
#include "debug.h"
#include "hcs.h"

/***************************************************************************/

void logfuncs(char *fun)
{
  static char *lf = "main"; /*, *of = NULL;*/
  char r[50];
  static char *c[20];
  static int i = 0, j, k = 0;
  static int fccc;
  
  /* alle funktionsnamen in diesem string werden nicht im logfile erfasst*/
  /* nologfunctions is defined in tefax.h : "pfnp pfnn pfnf pfnx isg3 cutonend";*/
  static char *nolog = nologfunctions;
  static FILE *ptfl = NULL;
  
  /* main() wird nicht aufgerufen, -> fuer funktionen called by main
  ** nachdem das programm in die mainebene zurueckkehrt und last-called-function lf
  ** einen anderen wert als "main" angenommen hat */
  c[0] = "main";
  
  if (!ptfl)
    ptfl = fopen("FUNCTION.log", "w");
  
  /* NULL-zeiger im parameter bezeichnen das funktionsende und der zaehler fuer
  ** die aufruftiefe wird dekrementiert */
  if (!fun) {if (fccc > 0) fccc--;}
  
  /* wiederholte aufrufe der gleichen funktion werden in i mitgezaehlt
  ** ausserdem muss der zaehler fuer die aufruftiefe erhoeht werden, weil er am
  ** funktionende durch CE immer dekrementiert wird. k enthaelt die anzahl der 
  ** spalten, die die last-called-funktion einzuruecken ist, waehrend fccc die 
  ** aufruftiefe ueber alle, also auch nolog-, funktionen zaehlt --- weil beim 
  ** abbau der aufruftiefe alle funktionen gleichermassen beteiligt sind */
  else if (fun == lf) {
    i++;
    if (fccc < 15) k = fccc++;
  }
  
  /* der aufrtuf einer neuen funktion, fuehrt, falls der funktionsname nicht in
  ** nologfunctions enthalten ist, erst zur ausgabe der daten von last-called-function lf
  ** in c[19] steht jeweils die aufrufende function */
  else {
    if (!strstr(nolog, fun)) {
      
      /* k enthaelt die aufruftiefe, die for-schleife rueckt die zeile entsprechend ein */
      for(j = 0, r[0] = '\0'; j < k && j < 15; j++) strcat(r, "|  ");
      fprintf(ptfl, "%s%s \tcalled times: %-3d by %s\n", r, lf, i, c[19]);
      lf = fun;

      /* anfangswerte fuer die neue funktion setzen: zaehler, tiefe und called by (c[19])*/
      i = 1;   
      k = fccc;
      c[19] = c[k];
    }
    /*(  auf jeden fall wird der funktionsname eingetragen -- schon fuers debuggen :-) 
    **   und damit der zaehler fuer die aufruftiefe wieder stimmt */
    c[++fccc] = fun;
  }

  /* durch das reopen kann der static file-zeiger weiterverwendet werden und ausserdem
  ** bleibt die datei auch bei einem programmabsturz erhalten */
  fclose(ptfl);
  ptfl = fopen("FUNCTION.log", "a");
/*   of = fun; */
}











